LibExoYsUtilities = LibExoYsUtilities or {}
local LibExoY = LibExoYsUtilities

local CM = ZO_CallbackObject:New()
local EM = GetEventManager() 

LibExoY.name = "LibExoYsUtilities"



--[[ ---------------------------------- ]]
--[[ -- Feedback, Guide & Support Me -- ]]
--[[ ---------------------------------- ]]

-- 

function LibExoY.FeedbackSubmenu( name, esoui )
    local submenu = {
        type = "submenu", 
        name = LibExoY.AddIconToString(LIB_EXOY_FEEDBACK_SETTINGS, "esoui/art/icons/achievement_update11_dungeons_004.dds", 36, "front"),
        controls = {},
    }

    table.insert(submenu.controls,   {
        type = "description",
        text = LIB_EXOY_FEEDBACK_TEXT,
    } )

    table.insert(submenu.controls,   {
        type = "description",
        text = LIB_EXOY_FEEDBACK_INGAME_MAIL_TEXT,
        width = "half",
    } )
    table.insert(submenu.controls,   {
        type = "button",
        name = LIB_EXOY_FEEDBACK_INGAME_MAIL_BUTTON,
        tooltip = "",
        disabled = function() return GetWorldName() ~= "EU Megaserver" end,
        func = function()
            SCENE_MANAGER:Show('mailSend')
            zo_callLater(function() 
                    ZO_MailSendToField:SetText("@Exoy94")
                    ZO_MailSendSubjectField:SetText( name )
                    ZO_MailSendBodyField:TakeFocus()   
                end, 250)
        end,
        width = "half",
        tooltip = GetWorldName() ~= "EU Megaserver" and LIB_EXOY_FEEDBACK_INGAME_MAIL_WARNING or LIB_EXOY_FEEDBACK_INGAME_MAIL_LANGUAGE,
    } )

    if esoui then 
        table.insert(submenu.controls, { type = "divider" } )
        table.insert(submenu.controls,   {
            type = "description",
            text = LIB_EXOY_FEEDBACK_ESOUI_TEXT,
            width = "half",
        } )
        table.insert(submenu.controls,   {
            type = "button",
            name = LIB_EXOY_FEEDBACK_ESOUI_BUTTON,
            tooltip = "",
            func = function()
            RequestOpenUnsafeURL( "https://www.esoui.com/downloads/"..esoui )
            end,
            width = "half",
            --warning = LIB_EXOY_FEEDBACK_URL_WARNING,
        } )
    end

    table.insert(submenu.controls, { type = "divider" } )
    table.insert(submenu.controls,   {
        type = "description",
        text = LIB_EXOY_FEEDBACK_DONATION_TEXT,
        width = "half",
    } )
    table.insert(submenu.controls,   {
        type = "button",
        name = LIB_EXOY_FEEDBACK_DONATION_BUTTON,
        tooltip = LIB_EXOY_FEEDBACK_DONATION_TT,
        func = function()
          RequestOpenUnsafeURL( "https://www.buymeacoffee.com/exoy" )
        end,
        width = "half",
        --warning = LIB_EXOY_FEEDBACK_URL_WARNING,
    } )

    return submenu
end


--[[ --------------------------------- ]]
--[[ -- (Initial) Player Activation -- ]]
--[[ --------------------------------- ]]

local initialActivationDone = false

function LibExoY.RegisterInitialPlayerActivation(callback)
    if initialActivationDone then return end
    if not LibExoY.IsFunc(callback) then return end
    CM:RegisterCallback('InitialPlayerActivation', callback)
end

function LibExoY.RegisterPlayerActivation(callback)
    if not LibExoY.IsFunc(callback) then return end
    CM:RegisterCallback('PlayerActivation', callback)
end

function LibExoY.UnregisterPlayerActivation(callback)
    CM:UnregisterCallback('PlayerActivation', callback)
end

local function OnPlayerActivation() 
    if not initialActivationDone then 
        CM:FireCallbacks('InitialPlayerActivation')
        initialActivationDone = true
        CM:UnregisterAllCallbacks('InitialPlayerActivation')
    end
    CM:FireCallbacks('PlayerActivation')
end


--[[ -------------------- ]]
--[[ -- Initialization -- ]]
--[[ -------------------- ]]

local function InitModule(module) 
    LibExoY.ExeFunc( LibExoY[module.."_InitFunc"] )
end 


local function Initialize()
    LibExoY.vars = {}
    LibExoY.vars.charId = GetCurrentCharacterId()

    EM:RegisterForEvent(LibExoY.name.."InitialActivation", EVENT_PLAYER_ACTIVATED, OnPlayerActivation)
    InitModule("Dialogs")
    InitModule("CombatStateManager")
end


local function OnAddonLoaded(_, addonName)
    if addonName == LibExoY.name then
        EM:UnregisterForEvent(LibExoY.name, EVENT_ADD_ON_LOADED)
        Initialize()
    end
end
  
EM:RegisterForEvent(LibExoY.name, EVENT_ADD_ON_LOADED, OnAddonLoaded)

