LibExoYsUtilities = LibExoYsUtilities or {}

local LibExoY = LibExoYsUtilities

--[[ ---------------- ]]
--[[ -- Chat Debug -- ]]
--[[ ---------------- ]]

-- used in 
--    + TributesEnhancement.lua

-- params
--    + trigger (func or bool)    --> determines whether chat debug is printed
--    + des     (string)          --> designation of addon
--    + text    (string or table) --> 
--    + delim   (table)           --> defines delimiter if 'text' is table 


local function ChatDebug(color, trigger, des, text, delim)
  -- early outs
  if LibExoY.IsFunc(trigger) then 
    if not trigger() then
      return
    end
  elseif not trigger then
    return
  end

  local output = zo_strformat("[<<1>>-<<2>>-", LibExoY.GetTimeString(true), GetGameTimeMilliseconds() )
  output = zo_strformat("<<1>><<2>><<3>> ", LibExoY.ColorString(output, "8F8F8F"), LibExoY.ColorString(des, color), LibExoY.ColorString("]","8F8F8F") )

  if LibExoY.IsTable( text ) then
   for k, v in ipairs(text) do
      local str = LibExoY.IsString(v) and v or tostring(v)
      output = string.format("%s%s", output, str)
      if delim[k] then
        output = string.format("%s%s", output, delim[k])
      end
   end
   d( output )
  else
   d( zo_strformat("<<1>><<2>>", output, text ) )
  end
end


function LibExoY.DebugMsg(...)
  ChatDebug("00FF00" , ...)
end


function LibExoY.DebugWarning(...)
  ChatDebug("ff8800" , ...)
end

function LibExoY.DebugError(...) 
  ChatDebug("FF0000" , ...)
end