LibExoYsUtilities = LibExoYsUtilities or {}
local LibExoY = LibExoYsUtilities


function LibExoY.IsTable( t )
  return type(t) == "table"
end

function LibExoY.IsFunc( f )
  return type(f) == "function"
end

function LibExoY.ExeFunc( f, p ) 
  if LibExoY.IsFunc(f) then return f(p) end
end

function LibExoY.IsString( s ) 
  return type(s) == "string"
end

function LibExoY.IsNumber( n ) 
  return type(n) == "number"
end

function LibExoY.IsAccount( s )
	return string.find(s, "@") ~= nil
end




--[[ -- String Functions -- ]]

-- todo, function to check if strings begins with a space 
function LibExoY.IsFirstCharacterSpace(s)
  if not LibExoY.IsString(s) then return end
  return string.sub(s,1,1) == " "
end
-- 

-- todo, check if string only consists of spaces 
function LibExoY.IsStringEmpty(s) 
  return s == ""
end




--[[ --------------------- ]]
--[[ -- Table Functions -- ]]
--[[ --------------------- ]]

-- /Media.lua/LibExoY.GetOutlineNumber()
-- /Media.lua/LibExoY.GetFontNumber()
-- /SavedVariables/PM:GetIdByName()


-- finds the key k, which has the entry e (unsure about table support) 
-- if value is not found then default value d is returned
function LibExoY.FindNumericKey(t, e, d) 
  for k,v in ipairs(t) do
    if e == v then 
      return k
    end
  end
  return d 
end 


function LibExoY.VerifyHashTable(t, e) 
  if not LibExoY.IsTable(t) then return false end 
  for _,ev in ipairs(e) do 
    if not t[ev] then return false end
  end
  return true
end

-- returns >true> if duplicate string is found in t
-- only applicable to tables containing strings 
-- if "cases" is true, than capitalization is considered
--  e.g.  cases = true  ->  "Dog" and "dog" are not! duplicates
--        cases = false ->  "Dog" and "dog" are duplicates 
function LibExoY.HasDuplicateString(t, s, cases) 
  local d = false
  for _,v in pairs(t) do 
    if cases then 
      if v == s then d = true break end
    else 
      if string.lower(v) == string.lower(s) then d = true break end
    end
  end
  return d 
end
-- /script d(LibExoYsUtilities.CheckDuplicateString({"Dog", "Cat"},"dog"))